#####################################################################
#
# Denial of Service Addon
# by plushpuffin
# plushpuffin@wwddfd.com
# http://www.wwddfd.com/
#
#####################################################################

push(@Addons_Loaded, 'DOS 1.0');
if( $NPConfig{'DOSMinDelay'} > 0 ) {
	unshift(@Addons_SaveNews, 'DOS_SaveNews');
}
push(@Addons_AdvancedSettingsLoad, 'DOS_AdvancedSettingsLoad');
&CheckBuild(32, "DOS 1.0", "npa_dos.pl");
$Addons_List{'DOS 1.0'} = ['npa_dos.pl', q~Denial of Service addon for NewsPro. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a> - <b><a href="http://www.wwddfd.com/">perl garden</a></b>~];
if( $NPConfig{'DOSMinDelay'} eq '' ) { $NPConfig{'DOSMinDelay'} = 15; }


sub DOS_AdvancedSettingsLoad {
$AdvDescr{'DOSMinDelay'} = "Minimum required delay (in seconds) between posts.";
push(@advancedsettings, 'draw_line','DOSMinDelay');
}

sub DOS_SaveNews {
	if( time < $NewsData[$#NewsData]->{'newstime'} + $NPConfig{'DOSMinDelay'} ) {
		&NPHTMLHead('DOS : Post Too Soon');
		print "<h2>A news item has been posted within the last ";
		my $minutes = int( $NPConfig{'DOSMinDelay'} / 60 );
		my $seconds = $NPConfig{'DOSMinDelay'} % 60;
		if( $minutes > 0 ) {
			print $minutes;
			print ( $minutes > 1 ? ' minutes ' : ' minute ' );
		}
		if( $seconds > 0 ) {
			print $seconds;
			print ( $seconds > 1 ? ' seconds' : ' second' );
		}
		print '. You must wait before posting again.</h2>';
		&NPHTMLFoot;
		exit;
	}
}

1;
             